#include <stdlib.h>
#include <stdio.h>
#include "screen.h"

extern int sin_tbl[] ;
extern int cos_tbl[] ;

int rot()
{
struct  VRAM_PIX *dst =(struct VRAM_PIX*)VRAM_TOP ;
struct  VRAM_PIX *src1=(struct VRAM_PIX*)(VRAM_TOP+320*sizeof(struct VRAM_PIX)) ;
struct  VRAM_PIX *src2=(struct VRAM_PIX*)(VRAM_TOP+(320+200*VRAM_WIDTH)*sizeof(struct VRAM_PIX)) ;
int x, y ;
int u, v ;
int i, o ; 

 for( i=256,o=0 ; i>=0 ; i-=8,o+=8 ){
   o=o%512 ;
   for( y=0 ; y<SCREEN_HEIGHT ; y++ ){
     for( x=0 ; x<SCREEN_WIDTH ; x++ ){
       u = (((((x-160)*i/256)*cos_tbl[o]-((y-100)*i/256)*sin_tbl[o])/65536)+800)%320 ;
       v = (((((x-160)*i/256)*sin_tbl[o]+((y-100)*i/256)*cos_tbl[o])/65536)+500)%200 ;
       dst[y*VRAM_WIDTH+x].r=src2[v*VRAM_WIDTH+u].r ;
       dst[y*VRAM_WIDTH+x].g=src2[v*VRAM_WIDTH+u].g ;
       dst[y*VRAM_WIDTH+x].b=src2[v*VRAM_WIDTH+u].b ;
     }
   }
 }

 for( i=0,o=0 ; i<=512 ; i+=8,o+=8 ){
   o=o%512 ;
   for( y=0 ; y<SCREEN_HEIGHT ; y++ ){
     for( x=0 ; x<SCREEN_WIDTH ; x++ ){
       u = (((((x-160)*i/256)*cos_tbl[o]-((y-100)*i/256)*sin_tbl[o])/65536)+800)%320 ;
       v = (((((x-160)*i/256)*sin_tbl[o]+((y-100)*i/256)*cos_tbl[o])/65536)+500)%200 ;
       dst[y*VRAM_WIDTH+x].r=src2[v*VRAM_WIDTH+u].r ;
       dst[y*VRAM_WIDTH+x].g=src2[v*VRAM_WIDTH+u].g ;
       dst[y*VRAM_WIDTH+x].b=src2[v*VRAM_WIDTH+u].b ;
     }
   }
 }
  return 0 ;
}
